Index: trunk/source/Lib/TLibCommon/TComMotionInfo.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComMotionInfo.h	(revision 964)
+++ trunk/source/Lib/TLibCommon/TComMotionInfo.h	(revision 976)
@@ -198,5 +198,5 @@
 //! \}
 
-#if ETRIKHU_CLEANUP_H0083
+#if H_3D_IV_MERGE
 class TComMotionCand
 {
Index: trunk/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPic.cpp	(revision 964)
+++ trunk/source/Lib/TLibCommon/TComPic.cpp	(revision 976)
@@ -55,5 +55,5 @@
 , m_bReconstructed                        (false)
 , m_bNeededForOutput                      (false)
-#if H_MV_HLS_7_VPS_P0300_27
+#if H_MV
 , m_bPicOutputFlag                        (false)
 #endif
Index: trunk/source/Lib/TLibCommon/TComPic.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComPic.h	(revision 964)
+++ trunk/source/Lib/TLibCommon/TComPic.h	(revision 976)
@@ -69,5 +69,5 @@
   Bool                  m_bReconstructed;
   Bool                  m_bNeededForOutput;
-#if H_MV_HLS_7_VPS_P0300_27
+#if H_MV
   Bool                  m_bPicOutputFlag;         // Semantics variable 
 #endif
@@ -178,5 +178,5 @@
   Void          setOutputMark (Bool b) { m_bNeededForOutput = b;     }
   Bool          getOutputMark ()       { return m_bNeededForOutput;  }
- #if H_MV_HLS_7_VPS_P0300_27
+ #if H_MV
   Void          setPicOutputFlag(Bool b) { m_bPicOutputFlag = b;      }
   Bool          getPicOutputFlag()       { return m_bPicOutputFlag ;  }
Index: trunk/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 964)
+++ trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 976)
@@ -500,8 +500,6 @@
   Pel* pDst = piPred;
   xAssignBiSegDCs( pDst, uiStride, biSegPattern, patternStride, segDC1, segDC2 );
-#if HS_DMM_SDC_PREDICTOR_UNIFY_H0108
   pcCU->setDmmPredictor(segDC1, 0);
   pcCU->setDmmPredictor(segDC2, 1);
-#endif
 
 #if H_3D_DIM_DMM
@@ -523,5 +521,5 @@
       Int RefPOCL0 = pcCU->getSlice()->getRefPic(REF_PIC_LIST_0, pcCU->getCUMvField(REF_PIC_LIST_0)->getRefIdx(PartAddr))->getPOC();
       Int RefPOCL1 = pcCU->getSlice()->getRefPic(REF_PIC_LIST_1, pcCU->getCUMvField(REF_PIC_LIST_1)->getRefIdx(PartAddr))->getPOC();
-#if MTK_ALIGN_SW_WD_BI_PRED_ARP_H0085
+#if H_3D_ARP
       if(!pcCU->getARPW(PartAddr) && RefPOCL0 == RefPOCL1 && pcCU->getCUMvField(REF_PIC_LIST_0)->getMv(PartAddr) == pcCU->getCUMvField(REF_PIC_LIST_1)->getMv(PartAddr))
 #else
@@ -647,18 +645,8 @@
   
   // start mapping process
-#if !MTK_DBBP_AMP_REM_H0072
-  Bool bAMPAvail = uiSize > 8;
-  Int matchedPartSum[6][2] = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}; // counter for each part size and boolean option
-  PartSize virtualPartSizes[6] = { SIZE_Nx2N, SIZE_2NxN, SIZE_2NxnU, SIZE_2NxnD, SIZE_nLx2N, SIZE_nRx2N };
-#else
   Int matchedPartSum[2][2] = {{0,0},{0,0}}; // counter for each part size and boolean option
   PartSize virtualPartSizes[2] = { SIZE_Nx2N, SIZE_2NxN};
-#endif
   
   UInt uiHalfSize = uiSize>>1;
-#if !MTK_DBBP_AMP_REM_H0072
-  UInt uiQuarterSize = uiSize>>2;
-#endif
-  
   for (Int y=0; y<uiSize; y+=iSubSample)
   {
@@ -691,49 +679,4 @@
         matchedPartSum[1][1-ucSegment]++;
       }
-      
-#if !MTK_DBBP_AMP_REM_H0072
-      if( bAMPAvail )
-      {
-        // SIZE_2NxnU
-        if(y<uiQuarterSize)  // top (1/4)
-        {
-          matchedPartSum[2][ucSegment]++;
-        }
-        else  // bottom (3/4)
-        {
-          matchedPartSum[2][1-ucSegment]++;
-        }
-        
-        // SIZE_2NxnD
-        if(y<(uiQuarterSize*3))  // top (3/4)
-        {
-          matchedPartSum[3][ucSegment]++;
-        }
-        else  // bottom (1/4)
-        {
-          matchedPartSum[3][1-ucSegment]++;
-        }
-        
-        // SIZE_nLx2N
-        if(x<uiQuarterSize)  // left (1/4)
-        {
-          matchedPartSum[4][ucSegment]++;
-        }
-        else  // right (3/4)
-        {
-          matchedPartSum[4][1-ucSegment]++;
-        }
-        
-        // SIZE_nRx2N
-        if(x<(uiQuarterSize*3))  // left (3/4)
-        {
-          matchedPartSum[5][ucSegment]++;
-        }
-        else  // right (1/4)
-        {
-          matchedPartSum[5][1-ucSegment]++;
-        }
-      }
-#endif
     }
     
@@ -745,9 +688,5 @@
   
   Int iMaxMatchSum = 0;
-#if !MTK_DBBP_AMP_REM_H0072
-  for(Int p=0; p<6; p++)  // loop over partition
-#else
   for(Int p=0; p<2; p++)  // loop over partition
-#endif
   {
     for( Int b=0; b<=1; b++ ) // loop over boolean options
@@ -859,9 +798,7 @@
   
   UInt  uiMaskStride= MAX_CU_SIZE;
-#if SEC_DBBP_FILTERING_H0104
   Pel  filSrc = 0;
   Pel* tmpTar = 0;
   tmpTar = (Pel *)xMalloc(Pel, uiWidth*uiHeight);
-#endif
   
   // backup pointer
@@ -877,26 +814,12 @@
       
       // filtering
-#if SEC_DBBP_FILTERING_H0104
       tmpTar[y*uiWidth+x] = piSrc[ucSegment][x];
-#else
-      Bool t = (y==0)?pMaskStart[(y+1)*uiMaskStride+x]:pMaskStart[(y-1)*uiMaskStride+x];
-      Bool l = (x==0)?pMaskStart[y*uiMaskStride+x+1]:pMaskStart[y*uiMaskStride+x-1];
-      Bool b = (y==uiHeight-1)?pMaskStart[(y-1)*uiMaskStride+x]:pMaskStart[(y+1)*uiMaskStride+x];
-      Bool r = (x==uiWidth-1)?pMaskStart[y*uiMaskStride+x-1]:pMaskStart[y*uiMaskStride+x+1];
-      
-      Bool bBlend = !((t&&l&&b&&r) || (!t&&!l&&!b&&!r));
-      piDst[x] = bBlend?((piSrc[0][x]+piSrc[1][x]+1)>>1):piSrc[ucSegment][x];
-#endif
     }
     
     piSrc[0]  += uiSrcStride;
     piSrc[1]  += uiSrcStride;
-#if !SEC_DBBP_FILTERING_H0104
-    piDst     += uiDstStride;
-#endif
     pMask     += uiMaskStride;
   }
   
-#if SEC_DBBP_FILTERING_H0104
   for (Int y=0; y<uiHeight; y++)
   {
@@ -933,5 +856,4 @@
   }
   if ( tmpTar    ) { xFree(tmpTar);             tmpTar        = NULL; }
-#endif
   
   // now combine chroma
@@ -944,10 +866,8 @@
   UInt  uiWidthC        = uiWidth >> 1;
   UInt  uiHeightC       = uiHeight >> 1;
-#if SEC_DBBP_FILTERING_H0104
   Pel  filSrcU = 0, filSrcV = 0;
   Pel* tmpTarU = 0, *tmpTarV = 0;
   tmpTarU = (Pel *)xMalloc(Pel, uiWidthC*uiHeightC);
   tmpTarV = (Pel *)xMalloc(Pel, uiWidthC*uiHeightC);
-#endif
   pMask = pMaskStart;
   
@@ -960,18 +880,6 @@
       
       // filtering
-#if SEC_DBBP_FILTERING_H0104
       tmpTarU[y*uiWidthC+x] = piSrcU[ucSegment][x];
       tmpTarV[y*uiWidthC+x] = piSrcV[ucSegment][x];
-#else
-      Bool t = (y==0)?pMaskStart[(y+1)*2*uiMaskStride+x*2]:pMaskStart[(y-1)*2*uiMaskStride+x*2];
-      Bool l = (x==0)?pMaskStart[y*2*uiMaskStride+(x+1)*2]:pMaskStart[y*2*uiMaskStride+(x-1)*2];
-      Bool b = (y==uiHeightC-1)?pMaskStart[(y-1)*2*uiMaskStride+x*2]:pMaskStart[(y+1)*2*uiMaskStride+x*2];
-      Bool r = (x==uiWidthC-1)?pMaskStart[y*2*uiMaskStride+(x-1)*2]:pMaskStart[y*2*uiMaskStride+(x+1)*2];
-      
-      Bool bBlend = !((t&&l&&b&&r) || (!t&&!l&&!b&&!r));
-      
-      piDstU[x] = bBlend?((piSrcU[0][x]+piSrcU[1][x]+1)>>1):piSrcU[ucSegment][x];
-      piDstV[x] = bBlend?((piSrcV[0][x]+piSrcV[1][x]+1)>>1):piSrcV[ucSegment][x];
-#endif
     }
     
@@ -980,12 +888,7 @@
     piSrcV[0]   += uiSrcStrideC;
     piSrcV[1]   += uiSrcStrideC;
-#if !SEC_DBBP_FILTERING_H0104
-    piDstU      += uiDstStrideC;
-    piDstV      += uiDstStrideC;
-#endif
     pMask       += 2*uiMaskStride;
   }
 
-#if SEC_DBBP_FILTERING_H0104
   for (Int y=0; y<uiHeightC; y++)
   {
@@ -1035,5 +938,4 @@
   if ( tmpTarU    ) { xFree(tmpTarU);             tmpTarU        = NULL; }
   if ( tmpTarV    ) { xFree(tmpTarV);             tmpTarV        = NULL; }
-#endif
 }
 #endif
@@ -2328,59 +2230,10 @@
   if (orgDC == false)
   {
-#if !HS_DMM_SDC_PREDICTOR_UNIFY_H0108
-    if ( getDimType(uiIntraMode) == DMM1_IDX )
-    {
-      UChar ucSegmentLT = pMask[0];
-      UChar ucSegmentRT = pMask[uiSize-1];
-      UChar ucSegmentLB = pMask[uiMaskStride * (uiSize-1)]; 
-      UChar ucSegmentRB = pMask[uiMaskStride * (uiSize-1) + (uiSize-1)]; 
-
-      rpSegMeans[ucSegmentLT] = pOrig[0];
-      rpSegMeans[ucSegmentRT] = pOrig[uiSize-1];
-      rpSegMeans[ucSegmentLB] = pOrig[uiStride * (uiSize-1) ];
-      rpSegMeans[ucSegmentRB] = pOrig[uiStride * (uiSize-1) + (uiSize-1) ];
-    }
-    else if( getDimType( uiIntraMode ) == DMM4_IDX )
-    {
-      Pel *ptmpOrig = pOrig;
-      Bool *ptmpMask = pMask, bBreak = false;
-      UChar ucSegment = ptmpMask? (UChar) ptmpMask[0] : 0;
-      UChar bFirstSeg = ucSegment;
-
-      rpSegMeans[ucSegment] = ptmpOrig[0];
-      for ( Int y = 0; y < uiSize; y++ )
-      {
-        for ( Int x = 0; x < uiSize; x++ )
-        {
-          ucSegment = ptmpMask[x];
-          assert( ucSegment < uiNumSegments );
-
-          if( bFirstSeg != ucSegment )
-          {
-            rpSegMeans[ucSegment] = ptmpOrig[x];
-            bBreak = true;
-            break;
-          }
-        }
-
-        if( bBreak )
-        {
-          break;
-        }
-
-        ptmpOrig  += uiStride;
-        ptmpMask  += uiMaskStride;
-      }
-    }
-    else
-#endif
-    {
-      Pel* pLeftTop = pOrig;
-      Pel* pRightTop = pOrig + (uiSize-1);
-      Pel* pLeftBottom = (pOrig+ (uiStride*(uiSize-1)));
-      Pel* pRightBottom = (pOrig+ (uiStride*(uiSize-1)) + (uiSize-1));
-
-      rpSegMeans[0] = (*pLeftTop + *pRightTop + *pLeftBottom + *pRightBottom + 2)>>2;
-    }
+    Pel* pLeftTop = pOrig;
+    Pel* pRightTop = pOrig + (uiSize-1);
+    Pel* pLeftBottom = (pOrig+ (uiStride*(uiSize-1)));
+    Pel* pRightBottom = (pOrig+ (uiStride*(uiSize-1)) + (uiSize-1));
+
+    rpSegMeans[0] = (*pLeftTop + *pRightTop + *pLeftBottom + *pRightBottom + 2)>>2;
     return;
   }
Index: trunk/source/Lib/TLibCommon/TComRom.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComRom.cpp	(revision 964)
+++ trunk/source/Lib/TLibCommon/TComRom.cpp	(revision 976)
@@ -360,5 +360,5 @@
 Char  g_aucConvertToBit  [ MAX_CU_SIZE+1 ];
 
-#if MTK_LOW_LATENCY_IC_ENCODING_H0086
+#if H_3D_IC
 UInt g_aICEnableCANDIDATE[10] = { 0, };
 UInt g_aICEnableNUM[ 10 ] = { 0, };
Index: trunk/source/Lib/TLibCommon/TComRom.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComRom.h	(revision 964)
+++ trunk/source/Lib/TLibCommon/TComRom.h	(revision 976)
@@ -189,8 +189,8 @@
 extern       Char   g_aucConvertToBit  [ MAX_CU_SIZE+1 ];   // from width to log2(width)-2
 
-#if MTK_LOW_LATENCY_IC_ENCODING_H0086
+#if H_3D_IC
 extern UInt g_aICEnableCANDIDATE[10];
 extern UInt g_aICEnableNUM[ 10 ]; //10 layers
-extern Int g_lastlayer;
+extern Int  g_lastlayer;
 #endif
 
Index: trunk/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComSlice.cpp	(revision 964)
+++ trunk/source/Lib/TLibCommon/TComSlice.cpp	(revision 976)
@@ -48,5 +48,5 @@
 TComSlice::TComSlice()
 : m_iPPSId                        ( -1 )
-#if H_MV_HLS_8_POC_Q0142_32
+#if H_MV
 , m_slicePicOrderCntLsb           ( 0 )
 #endif
@@ -1863,5 +1863,5 @@
 #endif
 {
-#if H_MV_HLS_8_SYN_Q0041_03
+#if H_MV
   m_vpsBaseLayerInternalFlag = true; 
 #endif
@@ -1883,10 +1883,6 @@
   m_vpsNumProfileTierLevelMinus1 = -1; 
     
-#if H_MV_HLS_8_SYN_39_19
   m_numAddLayerSets              = 0;   
   m_numAddOlss                   = 0; 
-#else
-  m_numAddLayerSets              = -1;   
-#endif
   m_defaultOutputLayerIdc     = 0; 
   
@@ -1902,15 +1898,10 @@
   }
 
-#if H_MV_HLS_8_PMS_Q0195_20
   m_repFormatIdxPresentFlag = false; 
-#endif
   m_maxOneActiveRefLayerFlag = false; 
   m_directDepTypeLenMinus2   = 0;         
   
 
-#if H_MV_HLS_8_RPS_Q0100_36
   m_vpsExtensionFlag = true; 
-#endif
-  m_avcBaseLayerFlag = false;
   m_vpsNonVuiExtensionLength = 0;
   m_splittingFlag    = false;
@@ -2032,10 +2023,7 @@
   }
 
-
-#if H_MV_HLS_8_PMS_Q0195_20
   //The value of vps_num_rep_formats_minus1 shall be in the range of 0 to 255, inclusive.
   assert( getVpsNumRepFormatsMinus1() >= 0 ); 
   assert( getVpsNumRepFormatsMinus1() <= 255 ); 
-#endif
 
   return true; 
@@ -2083,5 +2071,4 @@
   }
 
-#if H_MV_HLS_8
   for (Int i = 0 ; i < MAX_NUM_LAYER_IDS; i++ )
   {
@@ -2096,5 +2083,4 @@
     }
   }
-
 
   for( Int i = 0; i  <=  getMaxLayersMinus1(); i++ )
@@ -2107,5 +2093,4 @@
     }
   }
-
 
   for( Int i = 0; i <= getMaxLayersMinus1(); i++ )  // Bug in spec "<" instead of "<=" 
@@ -2149,5 +2134,4 @@
     m_numIndependentLayers = k;
   }
-#endif
 }
 
@@ -2314,9 +2298,5 @@
 Int    TComVPS::getNumOutputLayerSets() 
 {
-#if H_MV_HLS_8_SYN_39_19
   return getNumAddOlss() + getNumLayerSets(); 
-#else
-  return getNumAddLayerSets() + getVpsNumLayerSetsMinus1() + 1; 
-#endif
 }
 
@@ -2384,7 +2364,5 @@
     }
   }  
-#if H_MV_HLS_8_PMS_Q0165_18
   assert( getNumOutputLayersInOutputLayerSet( i ) > 0 ); 
-#endif
 }
 
@@ -2420,20 +2398,12 @@
 {
   Int maxSLMinus1 = 0; 
-#if H_MV_HLS_8_MIS_Q0102_30
   for( Int k = 0; k < getNumLayersInIdList( i ); k++ )
   {
     Int lId = m_layerSetLayerIdList[i][k];
-#else  
-  Int optLsIdx    = olsIdxToLsIdx( i );
-
-  for( Int k = 0; k < getNumLayersInIdList( optLsIdx ); k++ )
-  {
-    Int lId = m_layerSetLayerIdList[optLsIdx][k];
-#endif
     maxSLMinus1 = std::max( maxSLMinus1, getSubLayersVpsMaxMinus1( getLayerIdInVps( lId ) ));
   }
   return maxSLMinus1;
 }
-#if H_MV_HLS_8_RPS_Q0100_36
+
 Void TComVPS::inferDbpSizeLayerSetZero( TComSPS* sps, Bool encoder )
 {
@@ -2458,5 +2428,50 @@
   }
 }
-#endif
+
+Bool TComVPS::getAltOutputLayerFlagVar( Int i )
+{
+  // Semantics variable not syntax element !
+
+  Bool altOptLayerFlag = false;     
+  if ( i > 0 && getNumOutputLayersInOutputLayerSet( i ) == 1 && 
+    getNumDirectRefLayers( getOlsHighestOutputLayerId( i ) ) > 0 )
+  {
+    altOptLayerFlag = getAltOutputLayerFlag( i ); 
+  }
+  return altOptLayerFlag;
+}
+
+Int TComVPS::getMaxNumPics( Int layerId )
+{
+  Int maxNumPics = MAX_INT; 
+  for( Int olsIdx = 0; olsIdx < getNumOutputLayerSets(); olsIdx++)
+  {
+    Int lsIdx = olsIdxToLsIdx( olsIdx ); 
+    for( Int j = 0; j < getNumLayersInIdList( lsIdx ); j++ )
+    {
+      if( getLayerSetLayerIdList(lsIdx, j ) ==  layerId )
+      {
+        Int maxSL = getMaxSubLayersInLayerSetMinus1( lsIdx ); 
+        maxNumPics = std::min( maxNumPics, getDpbSize()->getMaxVpsDecPicBufferingMinus1( olsIdx , j,  maxSL ) );
+      }
+    }
+  }
+  assert( maxNumPics != MAX_INT ); 
+  return maxNumPics;
+}
+
+Void TComVPS::xSetRefLayerFlags( Int currLayerId )
+{
+  for( Int j = 0; j < getNumDirectRefLayers( currLayerId ); j++ )
+  {
+    Int refLayerId = m_refLayerId[ currLayerId ][ j ];
+    m_recursiveRefLayerFlag[ currLayerId ][ refLayerId ] = 1;
+    for( Int k = 0; k < MAX_NUM_LAYER_IDS; k++ )
+    {
+      m_recursiveRefLayerFlag[ currLayerId ][ k ] = m_recursiveRefLayerFlag[ currLayerId ][ k ]  ||  m_recursiveRefLayerFlag[ refLayerId ][ k ];
+    }
+  }
+}
+
 #endif // H_MV
 
@@ -2530,11 +2545,4 @@
   ::memset(m_usedByCurrPicLtSPSFlag, 0, sizeof(m_usedByCurrPicLtSPSFlag));
 #if H_MV
-#if !H_MV_HLS_8_SPS_NODOC_48
-  m_spsExtensionPresentFlag = false; 
-  for( Int i = 0; i < PS_EX_T_MAX_NUM; i++ ) 
-  {
-    m_spsExtensionTypeFlag[ i ] = false;
-  }
-#else 
   m_spsRangeExtensionsFlag     = false;
   m_spsMultilayerExtensionFlag = false;
@@ -2544,5 +2552,4 @@
 #else
   m_spsExtension6bits          = 0;
-#endif
 #endif
 
@@ -2726,5 +2733,4 @@
 
 #if H_MV
-#if H_MV_HLS_8_SPS_NODOC_48
   m_ppsRangeExtensionsFlag     = false;
   m_ppsMultilayerExtensionFlag = false;
@@ -2734,10 +2740,4 @@
   m_pps3dExtensionFlag         = false;
   m_ppsExtension5bits          = 0;
-#endif
-#else
-  for( Int i = 0; i < PS_EX_T_MAX_NUM; i++ ) 
-  {
-    m_ppsExtensionTypeFlag[ i ] = false;
-  }
 #endif
 #endif
@@ -2984,4 +2984,55 @@
   }
 }
+
+Void TComSPS::inferSpsMaxDecPicBufferingMinus1( TComVPS* vps, Int targetOptLayerSetIdx, Int currLayerId, Bool encoder )
+{
+  const std::vector<Int>& targetDecLayerIdList = vps->getTargetDecLayerIdList( vps->olsIdxToLsIdx( targetOptLayerSetIdx )); 
+
+  if (getLayerId() > 0 )
+  {
+    Int layerIdx = 0;         
+    while (layerIdx < (Int) targetDecLayerIdList.size() )
+    {
+      if ( targetDecLayerIdList[layerIdx] == currLayerId )
+      { 
+        break; 
+      }
+      layerIdx++; 
+    }
+
+    assert( layerIdx < (Int) targetDecLayerIdList.size() ); 
+
+    for (Int i = 0; i <= getSpsMaxSubLayersMinus1(); i++ ) 
+    {
+      Int maxDecPicBufferingMinus1 = vps->getDpbSize()->getMaxVpsDecPicBufferingMinus1( targetOptLayerSetIdx, layerIdx, i ) ; 
+
+      if ( encoder )
+      {
+        assert( getMaxDecPicBuffering( i ) - 1 == maxDecPicBufferingMinus1 ); 
+      }
+      else
+      {
+        setMaxDecPicBuffering(i, maxDecPicBufferingMinus1 + 1 ); 
+      }
+    }
+  }
+}
+
+Void TComSPS::checkRpsMaxNumPics( TComVPS* vps, Int currLayerId )
+{
+  // In spec, when rps is in SPS, nuh_layer_id of SPS is used instead 
+  // of nuh_layer_id of slice (currLayerId), this seems to be a bug.
+
+  for (Int i = 0; i < getRPSList()->getNumberOfReferencePictureSets(); i++ )
+  {
+    TComReferencePictureSet* rps = getRPSList()->getReferencePictureSet( i ); 
+    if ( !rps->getInterRPSPrediction() )
+    {
+      rps->checkMaxNumPics( vps->getVpsExtensionFlag(), vps->getMaxNumPics( currLayerId ), 
+        getLayerId(), getMaxDecPicBuffering( getSpsMaxSubLayersMinus1() ) - 1 );  
+    }
+  }
+}
+
 #endif
 
@@ -3133,4 +3184,19 @@
   printf("}\n");
 }
+#if H_MV
+Void TComReferencePictureSet::checkMaxNumPics( Bool vpsExtensionFlag, Int maxNumPics, Int nuhLayerId, Int spsMaxDecPicBufferingMinus1 )
+{
+  assert( getNumberOfPictures() >= 0 ); 
+  if ( nuhLayerId == 0 )
+  {
+    assert( getNumberOfPictures() <= spsMaxDecPicBufferingMinus1 ); 
+  }
+
+  if ( vpsExtensionFlag )
+  {
+    assert( getNumberOfPictures() <= maxNumPics );
+  }
+}
+#endif
 
 TComRPSList::TComRPSList()
@@ -3279,60 +3345,4 @@
 }
 
-#if !H_MV_HLS_8_DBP_NODOC_42
-Void TComSlice::markIvRefPicsAsUnused( TComPicLists* ivPicLists, std::vector<Int> targetDecLayerIdSet, TComVPS* vps, Int curLayerId, Int curPoc )
-{
-  // Fill targetDecLayerIdSet with all layers if empty (at encoder side) 
-  if (targetDecLayerIdSet.size() == 0 )    
-  {
-    for ( Int layerIdInVps = 0; layerIdInVps <= vps->getMaxLayersMinus1(); layerIdInVps++ )
-    {
-      targetDecLayerIdSet.push_back( vps->getLayerIdInNuh( layerIdInVps ) ); 
-    }
-  }     
-
-  Int numTargetDecLayers = (Int) targetDecLayerIdSet.size(); 
-  Int latestDecIdx; 
-  for ( latestDecIdx = 0; latestDecIdx < numTargetDecLayers; latestDecIdx++)
-  {
-    if ( targetDecLayerIdSet[ latestDecIdx ] == curLayerId )
-    {
-      break; 
-    }        
-  }        
-
-  for( Int i = 0; i <= latestDecIdx; i++ ) 
-  {
-    if ( vps->nuhLayerIdIncluded( targetDecLayerIdSet[ i ] ) )
-    {
-      TComPic* pcPic = ivPicLists->getPic( targetDecLayerIdSet[ i ], curPoc ); 
-      if ( pcPic )
-      {
-        if( pcPic->getSlice(0)->isReferenced() && pcPic->getSlice(0)->getTemporalLayerNonReferenceFlag() ) 
-        { 
-          Bool remainingInterLayerReferencesFlag = false; 
-          for( Int j = latestDecIdx + 1; j < numTargetDecLayers; j++ )
-          { 
-            TComVPS* vpsSlice = pcPic->getSlice(0)->getVPS(); 
-            if ( vps->nuhLayerIdIncluded( targetDecLayerIdSet[ j ] ) )
-            {
-              for( Int k = 0; k < vpsSlice->getNumDirectRefLayers( targetDecLayerIdSet[ j ] ); k++ )
-              {
-                if ( targetDecLayerIdSet[ i ] == vpsSlice->getRefLayerId( targetDecLayerIdSet[ j ],  k  ) )
-                {
-                  remainingInterLayerReferencesFlag = true;
-                }
-              }
-            }
-          }
-          if( !remainingInterLayerReferencesFlag )
-          {
-            pcPic->getSlice(0)->setReferenced( false );                   
-          }
-        }
-      }
-    }
-  }
-}
-#endif
 Void TComSlice::printRefPicList()
 {  
@@ -3351,23 +3361,9 @@
 Void TComSlice::markCurrPic( TComPic* currPic )
 {
-
-#if !H_MV_HLS_8_DBP_NODOC_42
-  if ( !currPic->getSlice(0)->getDiscardableFlag() )
-  {
-#endif
-    currPic->getSlice(0)->setReferenced( true ) ; 
-    currPic->setIsLongTerm( false ); 
-#if !H_MV_HLS_8_DBP_NODOC_42
-  }
-  else
-  {
-    currPic->getSlice(0)->setReferenced( false ) ; 
-  }
-#endif
-
-#if H_MV_HLS_7_VPS_P0300_27
+  currPic->getSlice(0)->setReferenced( true ) ; 
+  currPic->setIsLongTerm( false ); 
+
   currPic->setReconMark( true );
   currPic->setPicOutputFlag( currPic->getSlice(0)->getPicOutputFlag() );
-#endif
 }
 
@@ -3403,11 +3399,6 @@
   Int refLayerIdx = vps->getLayerIdInVps( vps->getRefLayerId( getLayerId(), i ) ); 
 
-#if H_MV_HLS_8_RPS_Q0060_17
   Bool refLayerPicFlag = ( vps->getSubLayersVpsMaxMinus1( refLayerIdx ) >=  getTLayer() )  && ( getTLayer() == 0  ) &&
     ( vps->getMaxTidIlRefPicsPlus1( refLayerIdx, vps->getLayerIdInVps( getLayerId() )) > getTLayer() ); 
-#else
-  Bool refLayerPicFlag = ( vps->getSubLayersVpsMaxMinus1( refLayerIdx ) >=  getTLayer() )  && 
-    ( vps->getMaxTidIlRefPicsPlus1( refLayerIdx, vps->getLayerIdInVps( getLayerId() )) > getTLayer() ); 
-#endif
 
   return refLayerPicFlag;       
@@ -3541,11 +3532,6 @@
 #endif
 #if H_3D_IC
-#if MTK_LOW_LATENCY_IC_ENCODING_H0086
 Void TComSlice::xSetApplyIC(Bool bUseLowLatencyICEnc)
-#else
-Void TComSlice::xSetApplyIC()
-#endif
-{
-#if MTK_LOW_LATENCY_IC_ENCODING_H0086
+{
   if(bUseLowLatencyICEnc)
   {
@@ -3592,5 +3578,5 @@
         Double ratio=Double(g_aICEnableNUM[refLayer])/Double(g_aICEnableCANDIDATE[refLayer]);
 
-        if( ratio > MTK_LOW_LATENCY_IC_ENCODING_THRESHOLD_H0086)
+        if( ratio > IC_LOW_LATENCY_ENCODING_THRESHOLD)
 {
           m_bApplyIC=true;
@@ -3608,5 +3594,4 @@
   else
   {
-#endif
   Int iMaxPelValue = ( 1 << g_bitDepthY ); 
   Int *aiRefOrgHist;
@@ -3682,7 +3667,5 @@
   aiCurrHist = NULL;
   aiRefOrgHist = NULL;
-#if MTK_LOW_LATENCY_IC_ENCODING_H0086
   }//if(bUseLowLatencyICEnc)
-#endif
 }
 #endif
@@ -3774,5 +3757,5 @@
 
 #if H_3D_DDD
-    InitializeDDDPara( vps->getCamParPrecision(), codScale[ i ], codOffset[ i ], i );
+    initializeDDDPara( vps->getCamParPrecision(), codScale[ i ], codOffset[ i ], i );
 #endif
   }
@@ -3782,5 +3765,5 @@
 
 #if H_3D_DDD
-Void TComSlice::InitializeDDDPara( UInt uiCamParsCodedPrecision, Int  iCodedScale,Int  iCodedOffset, Int iBaseViewIdx )
+Void TComSlice::initializeDDDPara( UInt uiCamParsCodedPrecision, Int  iCodedScale,Int  iCodedOffset, Int iBaseViewIdx )
 {
     UInt uiViewId     = getViewIndex();
@@ -3839,4 +3822,45 @@
 
     return;
+}
+
+
+#endif
+
+#if H_MV
+Void TComSlice::checkCrossLayerBlaFlag()
+{
+  // cross_layer_bla_flag shall be equal to 0 for pictures with nal_unit_type not equal to IDR_W_RADL or IDR_N_LP or with nuh_layer_id not equal to 0.
+  if ( getLayerId() != 0 || getNalUnitType() != NAL_UNIT_CODED_SLICE_IDR_W_RADL || getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_N_LP )
+  {
+    assert( m_crossLayerBlaFlag == 0 ); 
+  }
+}
+
+Bool TComSlice::inferPocMsbValPresentFlag()
+{
+  Bool pocMsbValPresentFlag; 
+  if( getSliceSegmentHeaderExtensionLength() == 0 ) 
+  {
+    pocMsbValPresentFlag = false; 
+  }
+  else if ( getPocMsbValRequiredFlag() )
+  {
+    pocMsbValPresentFlag = true; 
+  }
+  else
+  {
+    pocMsbValPresentFlag = false; 
+  }
+
+  return pocMsbValPresentFlag;
+}
+
+
+#endif
+
+#if H_3D_DBBP
+Int TComSlice::getDepthFromDV( Int iDV, Int iBaseViewIdx )
+{
+  return ClipY(( iDV * m_aiDDDInvScale[ iBaseViewIdx ] + m_aiDDDInvOffset[ iBaseViewIdx ] ) >> m_aiDDDShift[ iBaseViewIdx ]);
 }
 #endif
@@ -4331,4 +4355,17 @@
 }
 
+Void TComVpsVuiBspHrdParameters::checkBspCombHrdAndShedIdx( TComVPS* vps, Int h, Int i, Int j )
+{
+  // bsp_comb_hrd_idx
+  assert( getBspCombSchedIdx(h, i, j ) >= 0 );
+  assert( getBspCombSchedIdx(h, i, j ) <= getVpsNumBspHrdParametersMinus1() );
+
+  // bsp_comb_sched_idx
+  assert( getBspCombSchedIdx(h, i, j ) >= 0 );
+
+  //* This check needs to activated,  when HighestTid is available here    
+  //  assert(  getBspCombSchedIdx(h, i, j ) <= vps->getHrdParameters( getBspCombHrdIdx( h, i, j ) )->getCpbCntMinus1( highestTid ) );
+}
+
 Void TComVUI::inferVideoSignalInfo( TComVPS* vps, Int layerIdCurr )
 {
@@ -4370,3 +4407,16 @@
   }
 }
-#endif
+
+Void Window::scaleOffsets( Int scal )
+{
+  if (! m_scaledFlag )
+  {
+    m_scaledFlag         = true; 
+    m_winLeftOffset     *= scal; 
+    m_winRightOffset    *= scal; 
+    m_winTopOffset      *= scal; 
+    m_winBottomOffset   *= scal; 
+  }
+}
+#endif
+
